apiVersion: apps/v1
kind: Deployment
metadata:
  namespace: {{ .Release.Namespace }}
  name: portal-tomcat-deployment
spec:
  selector:
    matchLabels:
      app: portal-tomcat
  template:
    metadata:
      labels:
        app: portal-tomcat
      annotations:
        checksum/config1: {{ include (print $.Template.BasePath "/keycloak-configmap.yaml") . | sha256sum }}
        checksum/config2: {{ include (print $.Template.BasePath "/portal-configmap.yaml") . | sha256sum }}
    spec:
      initContainers:
        - name: wait-for-keycloak
          image: sequenceiq/busybox
          args:
          - /bin/sh
          - -c
          - >
            set -x;
            while [ $(curl -skw '%{http_code}' "http://keycloak-service.{{ .Values.sharedEnvironment }}.svc.cluster.local:8080/auth/realms/master" -o /dev/null) -ne 200 ]; do
              sleep 15;
            done
        - name: init-portal-config
          image: busybox:1.34.1
          command:
          - /bin/sh
          - -c
          - >
            echo "init Portal-Config (subsitute passwords)";
            cat /configPortal/backendConfig.json | sed -e "s#\$KEYCLOAK_PASSWORD_TECHUSER#$KEYCLOAK_PASSWORD_TECHUSER#g" > /config-readwrite/backendConfig.json;
            cat /config/keycloak-config.json | sed -e "s#\$KEYCLOAK_PASSWORD_TECHUSER#$KEYCLOAK_PASSWORD_TECHUSER#g" > /config-readwrite/keycloak-config.json;
            cat /config-readwrite/backendConfig.json;
          env:
            - name: KEYCLOAK_PASSWORD_TECHUSER
              valueFrom:
                secretKeyRef:
                  name: keycloak-secret-techuser
                  key: KEYCLOAK_PASSWORD_TECHUSER
          volumeMounts:
          - name: writeable-config
            mountPath: /config-readwrite
          - name: config-volume
            mountPath: /configPortal/backendConfig.json
            subPath: backendConfig.json
          - name: config-volume-keycloak
            mountPath: /config/keycloak-config.json
            subPath: keycloak-config.json
        - name: init-keycloak-config
          #image: adorsys/keycloak-config-cli:v4.0.1-14.0.0
          image: adorsys/keycloak-config-cli:5.8.0-22.0.0
          imagePullPolicy: IfNotPresent
          env:
            - name: KEYCLOAK_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: keycloak-secrets
                  key: KEYCLOAK_PASSWORD
            - name: KEYCLOAK_URL
              value: http://keycloak-service.{{ .Values.sharedEnvironment }}.svc.cluster.local:8080/auth
            - name: KEYCLOAK_AVAILABILITYCHECK_ENABLED
              value: "false"
            - name: KEYCLOAK_AVAILABILITYCHECK_TIMEOUT
              value: "10s"
            - name: IMPORT_FORCE
              value: "false"
          volumeMounts:
            - name: writeable-config
              mountPath: /config/keycloak-config.json
              subPath: keycloak-config.json
      containers:
        - image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: Always
          name: portal-tomcat
          env:
            - name: KEYCLOAK_PASSWORD_TECHUSER
              valueFrom:
                secretKeyRef:
                  name: keycloak-secret-techuser
                  key: KEYCLOAK_PASSWORD_TECHUSER
            - name: JAVA_TOOL_OPTIONS
              value: "-agentlib:jdwp=transport=dt_socket,address=5000,server=y,suspend=n"
          ports:
            - containerPort: 5000
              name: "jvm-debug"
            - containerPort: 8080
          volumeMounts:
          - name: writeable-config
            mountPath: /configPortal/backendConfig.json
            subPath: backendConfig.json
          - name: config-volume
            mountPath: /configPortal/moduleConfig.json
            subPath: moduleConfig.json
      volumes:
        - name: writeable-config
          emptyDir: {}
        - name: config-volume
          configMap:
            name: portal-config
            defaultMode: 0777
        - name: config-volume-keycloak
          configMap:
            name: keycloak-config
---
apiVersion: v1
kind: Service
metadata:
  namespace: {{ .Release.Namespace }}
  name: portal-service
spec:
  selector:
    app: portal-tomcat
  ports:
    - protocol: TCP
      port: 80
      targetPort: 8080